// Models
// Includes connectivity to MongoDB

//-- Register Articles in MongoDB
App.Datamodel.register('Article', {
    title   :  { 'type': String, 'default': 'Enter Title' },
    content :  { 'type': String, 'default': 'Enter Content' }
});

//-- Backbone

Article = Backbone.Model;

Articles = Backbone.Collection.Mongo.extend({
	
	model: Article,

	reference: App.Datamodel.Article,

	fetch: function() {

		var fn = this;
		
		// Populate collection with data from MongoDB
		this.reference.find({}, function(err, docs){
		    fn.reset(docs);		    
		});

		return this;
	},

	initialize: function() {
		
		var fn = this;

		// On add, create a new MongoDB entry
		this.bind('add', function(model) {

			var data = model.toJSON();
			
			fn.mongo_models[model.id] = new fn.schema(data).save();
		});

		// On remove, destroy the MongoDB entry
		this.bind('remove', function(model) {
			fn.mongo_models[model.id].destroy();
		});

		this.bind('reset', function() {
			App.send("updateDB", fn.toJSON());
		});		
	}

});
