// Name    : Example Backbone Server
// Author  : Nate Hunzaker 
// License : MIT

require('../lib/backbone-server');

//-- 1. Create Backbone.Server
App = new Backbone.Server({
    'port'           : 9000,
    'socketio'       : true,

    // Database Config
    'database'     : {
        'adapter'    : 'mongo',
        'location'   : 'mongodb://localhost/example_db'
    }
});

//-- 2. Require Modules
App.load('app/routes');
App.load('app/models');


//-- 3. Collections
articles = new Articles().fetch();


//-- 4. Socket.IO Events

App.bind('connection', function() {

    App.send('updateDB', articles.toJSON());

});


//-- 6. Start Server
App.start();