// Backbone Mongo
// An interface between mongo and backbone for server side interactions

var mongoose = require('mongoose');

// ---------------------------------------------------------------------------------------------------- //
module.exports.setup = function(options) {
	  mongoose.connect(options.location);	    
	  console.log("   info  - ".cyan+  "mongodb" + " is active at " + options.location.cyan);
};
// ---------------------------------------------------------------------------------------------------- //

// ---------------------------------------------------------------------------------------------------- //
// Telegraph.sync Overides
// ---------------------------------------------------------------------------------------------------- //

// Override `Backbone.sync` to use delegate to the model or collection's
Telegraph.sync = function(method, model, options) {

    var resp;

    switch (method) {
        
    case "read":

        var col = this,
        ref = this._datalink;

        var query = options.query || {};
        
        ref.find(query,  function(err, models) {
            resp = models;
            col.reset(models);
        });

        break;

    case "create":  
        var ref = this.collection._datalink;
        resp = new ref(model.toJSON()).save();
        break;

    case "update":  
        var ref = this._datalink;
        resp = ref.findById(model.id);
        resp = model.toJSON().save();
        break;

    case "delete":  
        var ref = this._datalink;
        var resp = ref.findById(model.id).destroy();
        break;
    }

    if (resp) {
        options.success(resp);
    } else {
        //   options.error("Record not found");
    }
};
